<!doctype html public "-//W3C//DTD HTML 4.0 Transitional //EN">
<html>
<head>
  <meta name="GENERATOR" content="mkd2html 2.1.8a DEBUG DL=DISCOUNT">
  <meta http-equiv="Content-Type"
        content="text/html; charset=utf-8">  <link rel="stylesheet"
        type="text/css"
        href="style.css" />
</head>
<body>
<p>Appunti Reti - &copy; 2017 Mario Cianciolo &lt;mr.udda@gmail.com&gt;</p>

<h1>Il sottolivello MAC</h1>

<p>Il <strong>MAC</strong> (<em>Medium Access Control</em>), sottolivello del livello Data Link, si occupa
di assegnare l'uso di un canale multiaccesso (broadcast), in particolare
in caso di competizione.</p>

<p>Il sottostrato MAC è molto importante nelle LAN, perché usano un mezzo condiviso.
Nelle reti più grandi si preferiscono connessioni punto-punto.</p>

<p>Si noti che nessun protocollo dello strato MAC garantisce una comunicazione affidabile:
i frame possono andare persi per motivi al di fuori del controllo dei protocolli (
mancanza di spazio di memorizzazione, interrupt perduto, etc).</p>

<h2>Indirizzi MAC</h2>

<p>Un indirizzo MAC (detto anche <strong>indirizzo fisico</strong>, <em>indirizzo ethernet</em> o <em>indirizzo LAN</em>)
è un codice di 48 bit (6 byte) assegnato in modo univoco dal produttore ad ogni scheda di
rete ethernet o wireless prodotta al mondo, tuttavia modificabile a livello software.</p>

<h3>Indirizzi globali e locali</h3>

<p>Il secondo bit significativo (46) degli indirizzi MAC distingue tra:</p>

<ul>
<li><strong>indirizzi globali</strong> (bit <code>0</code>): assegnati da IEEE e univoci in tutto il mondo</li>
<li><strong>indirizzi locali</strong> (bit <code>1</code>): assegnati dall'amministratore di rete e univoci all'interno della LAN</li>
</ul>


<p>Negli indirizzi globali, i primi 3 byte sono detti <strong>OUI</strong> (<em>Organizationally
Unique Identifier</em>) e identificano il produttore, gli altri 3 byte sono assegnati
dal produttore che deve rispettare il vincolo di unicità.</p>

<p>Negli indirizzi locali, tutti i byte sono assegnati dall'amministratore di rete.</p>

<h3>Notazione e formato</h3>

<p>I 48 bit del codice sono suddivisi in 12 cifre esadecimali: le prime 6 cifre individuano
il produttore dell'interfaccia di rete mentre le successive corrispondono al numero di
serie della scheda stessa.</p>

<p>L'indirizzo MAC si scrive in 6 ottetti separati da un trattino (es. <code>00-50-FC-A0-67-2C</code>).<br/>
Si preferisce la notazione esadecimale anche per differenziarla dagli indirizzi
IP che usano la notazione decimale.</p>

<h4>Schemi di indirizzamento flat</h4>

<p>Gli indirizzi MAC non hanno gerarchie (eccetto i tre byte del produttore), per cui
un dispositivo che li gestisce (es. un <strong>bridge</strong>) deve memorizzarli per intero,
e non ha necessità né possiblità di suddividerli in gruppi o organizzarli in gerarchia.</p>

<p>Questa proprietà rende <em>flat</em> lo schema di indirizzamento MAC.</p>

<h2>Tipi di protocolli Data Link</h2>

<h3>Stop and Wait</h3>

<p>Nei protocolli <strong>Stop and Wait</strong> il mittente, dopo aver inviato un frame,
attende un segnale del destinatario prima di continuare a inviare.</p>

<h3>Sliding window</h3>

<p>I protocolli <strong>Sliding Window</strong> prevedono che il mittente tenga
traccia di quali frame possono essere inviati e quali no.</p>

<p>Il mittente mantiene due indici:</p>

<ul>
<li>il numero di frame inviati e già confermati (ACK)</li>
<li>il numero di frame inviati e in attesa di conferma</li>
</ul>


<p>L'intervallo tra questi due indici è la <strong>finestra di invio</strong>.</p>

<p>Il destinatario ricorderà quali frame sono stati ricevuti,
mantenendo la <strong>finestra di ricezione</strong> costante.<br/>
Una finestra larga al massimo 1 equivale a forzare l'invio dei
frame in sequenza.</p>

<h3>Tecniche Data Link</h3>

<p>Di seguito alcune tecniche ricorrenti in molti protocolli.</p>

<h4>Piggy backing</h4>

<p>Il <strong>piggy backing</strong> è la pratica di mandare l'ACK di un frame
ricevuto insieme al prossimo frame da inviare, e non in un
frame a parte.</p>

<p>Si risparmia banda, ma è utile solo per i canali full ­duplex e
solo se il nuovo frame da inviare non si fa attendere troppo
(altrimenti il mittente, non ricevendo l'ACK, ripeterà l'invio).</p>

<h4>Pipelining</h4>

<p>Nel caso in cui il tempo di invio di un frame sommato al tempo
di ricezione dell'ACK non sia trascurabile (es. comunicazioni
satellitari) è bene usare un protocollo che usi una tecnica di
<strong>pipelining</strong>.</p>

<p>Il pipelining consiste nel continuare a inviare altri frame
mentre si aspettano gli ACK di quelli ricevuti.</p>

<p>Per rilevare e reinviare i frame perduti si usano due approcci:</p>

<ul>
<li><strong>go back n</strong>: se si perde un frame (o quello ricevuto è danneggiato),
il destinatario si limita a buttare tutti i frame successivi e il
mittente, non ricevendo più ACK, ricomincia dall'invio del primo frame
di cui non ha ricevuto l'ACK</li>
<li><strong>ripetizione selettiva</strong> (se la finestra di ricezione è maggiore di uno):
se si perde un frame, il destinatario continua a memorizzare in un buffer
i frame successivi, invia un NACK legato al singolo frame e attende che
il mittente lo rimandi</li>
</ul>


<h2>Diagrammi a traliccio e decodifica di Viterbi</h2>

<p>Attraverso uno schema di codifica (lato mittente) e decodifica (lato destinatario) è possibile rilevare e correggere un errore ogni 4 bit.</p>

<h4>Codifica</h4>

<p>La codifica consiste nella trasformazione di un singolo bit in una coppia di bit seguendo un determinato schema di trasformazione.</p>

<p>In particolare, si definiscono quattro stati (00, 01, 10, 11) che rappresentano il bit corrente e il bit precedente.<br/>
Si definisce un automa a stati finiti con questi quattro stati, tale che in ogni transizione da uno stato
all'altro ci sia sempre distanza di Hamming pari a 2.</p>

<p>Gli stati sono costruiti aggiungendo un terzo bit iniziale, che funge da parità, e aumenta la distanza di Hamming degli stati a 2. <br/>
Il terzo bit funge anche da indicatore della direzione delle transizioni, quando più di una
è possibile: in tal caso, va presa quella con il bit di partenza uguale al terzo bit iniziale.</p>

<p><img src="04_trellis_fsm.png" alt="Macchina a stati finiti per la codifica" /></p>

<p>Infine, si analizzano i bit a coppie (precedente e attuale), e si inviano i due bit
della transizione invece che quelli del dato.</p>

<p>La banda richiesta è raddoppiata (2 Gbps).</p>

<h5>Esempio</h5>

<p>Codificare la stringa <code>011001</code>:</p>

<ul>
<li>Transizione <code>--</code> -> <code>-0</code>: <code>00</code></li>
<li>Transizione <code>-0</code> -> <code>01</code>: <code>11</code></li>
<li>Transizione <code>01</code> -> <code>11</code>: <code>01</code></li>
<li>Transizione <code>11</code> -> <code>10</code>: <code>01</code></li>
<li>Transizione <code>10</code> -> <code>00</code>: <code>11</code></li>
<li>Transizione <code>00</code> -> <code>01</code>: <code>11</code></li>
</ul>


<p>Risultato: <code>00 11 01 01 11 11</code></p>

<h4>Decodifica</h4>

<p>La <strong>decodifica di Viterbi</strong>, consiste nell'andare a ricostruire la stringa originale seguendo lo schema di codifica a ritroso.</p>

<p>Tramite tale decodifica è possibile rilevare e correggere degli errori su una stringa di bit:
in caso di errore verrà trasmesso un percorso non valido, la decodifica utilizzerà quello più probabile
(il percorso valido con distanza di Hamming minima da quello ricevuto).</p>

<p><img src="04_trellis.svg" alt="Diagramma a traliccio" /></p>

<p>Utilizzando i cosiddetti <strong>diagrammi a traliccio</strong>, si tenta di ricostruire il
&ldquo;percorso&rdquo; compiuto dai bit della codifica. Ad ogni coppia di bit corrisponde
un bit decodificato.</p>

<p>Nel diagramma in figura, le linee continue corrispondono ad uno <code>0</code> in input, mentre
le linee tratteggiate ad un <code>1</code>.</p>

<p>Se la sequenza non è valida, si analizza la coppia successiva, si scrivono tutte le possibili
transizioni (quindi una sequenza di 4 bit) e si prende come corretta la sequenza che ha
distanza di Hamming minima da quella osservata (che per come è costruita la FSM sarà unica).</p>

<h5>Esempio</h5>

<p>Decodificare la stringa precedente <code>00 11 01 01 11 11</code>:</p>

<ul>
<li><code>00</code>: primo bit <code>0</code></li>
<li><code>11</code>: transizione da <code>00</code> a <code>01</code>, secondo bit <code>1</code></li>
<li><code>01</code>: transizione da <code>01</code> a <code>11</code>, terzo bit <code>1</code></li>
<li><code>01</code>: transizione da <code>11</code> a <code>10</code>, quarto bit <code>0</code></li>
<li><code>11</code>: transizione da <code>10</code> a <code>00</code>, quinto bit <code>0</code></li>
<li><code>11</code>: transizione da <code>00</code> a <code>01</code>, sesto bit <code>1</code></li>
</ul>


<h5>Esempio di correzione errori</h5>

<p>Ricezione della stringa <code>01 11</code></p>

<ul>
<li><code>01</code>: impossibile, il primo stato può essere solo <code>00</code> (bit <code>0</code>) o <code>10</code> (bit <code>1</code>), quindi c'è un errore</li>
<li>scrivo le transizioni possibili:

<ul>
<li><code>00 00</code> (bit risultanti <code>0 0</code>), distanza 3</li>
<li><code>11 10</code> (bit risultanti <code>1 0</code> o <code>0 1</code> a seconda del bit precedente), distanza 2</li>
<li><code>00 11</code> (bit risultanti <code>0 1</code>), distanza 1</li>
<li><code>11 01</code> (bit risultanti <code>1 1</code>), distanza 2</li>
</ul>
</li>
<li>scelgo il percorso a distanza 1 (<code>00 11</code>, che infatti è quello corretto)</li>
</ul>


<h2>Protocolli per l'assegnazione del canale</h2>

<p>Una possibile soluzione è l'assegnazione statica: il canale è diviso tramite multiplexing
(FDM o TDM) e ogni sottocanale è assegnato ad un utente.<br/>
L'assegnazione statica funziona bene solo con un numero prefissato (e piccolo)
di utenti, e con traffico pesante e continuo. Altrimenti la banda viene sprecata,
contemporaneamente impedendo ad altri utenti di usare il canale.</p>

<p>Per questi motivi, si preferiscono soluzioni di assegnazione dinamica del canale.</p>

<p>I seguenti algoritmi si basano su cinque premesse:</p>

<ol>
<li><strong>Modello della stazione</strong>: ci sono N stazioni indipendenti, ognuna genera
frame in trasmissione, e rimane bloccata finché il frame non è stato
trasmesso con successo</li>
<li><strong>Canale singolo</strong>: tutte le stazioni possono trasmettere e ricevere attraverso
un unico canale</li>
<li><strong>Collisione</strong>: due frame trasmessi contemporaneamente si sovrappongono almeno in
parte, e il segnale risultante è distorto.<br/>
Un frame entrato in collisione con un altro deve essere ritrasmesso.
Non esistono altri errori oltre alle collisioni.</li>
<li><ul>
<li><strong>Tempo continuo</strong>: le trasmissioni iniziano in qualsiasi momento</li>
<li><strong>Tempo diviso in intervalli</strong>: il tempo è diviso in intervalli (<em>slot</em>) discreti.
Ogni slot può contenere 0 (intervallo vuoto), 1 (trasmissione con successo) o più
(collisione) frame.</li>
</ul>
</li>
<li><ul>
<li><strong>Occupazione del canale verificabile</strong>: prima di tentare la trasmissione, le stazioni
possono controllare se il canale è in uso, ed evitare di trasmettere</li>
<li><strong>Occupazione del canale non verificabile</strong>: le stazioni trasmettono sempre, e
dopo possono soltanto verificare se la trasmissione ha avuto successo</li>
</ul>
</li>
</ol>


<p>I sistemi in cui sono possibili collisioni si chiamano <strong>sistemi a contesa</strong>.</p>

<h3>ALOHA puro</h3>

<p>Il principio è quello di consentire agli utenti di trasmettere in qualsiasi momento.</p>

<p>Tramite feedback o acknowledge, un trasmettitore controlla se il frame è stato trasmesso correttamente.
In caso contrario, il trasmettitore attende per un intervallo casuale e ritenta la trasmissione.<br/>
L'intervallo è casuale per tentare di evitare ulteriori collisioni.</p>

<p>I frame hanno tutti la stessa lunghezza perché questo massimizza la capacità di trasporto.</p>

<p><img src="04_aloha_collisioni.gif" alt="Esempio di trasmissioni in un canale ALOHA" /></p>

<p>Un frame viene perso se anche un solo bit di esso si sovrappone all'inizio o alla fine di un altro
frame (<strong>collisione parziale</strong>).</p>

<p><img src="04_aloha_puro.gif" alt="Periodo vulnerabile in ALOHA puro" /></p>

<h4>Efficienza di ALOHA puro</h4>

<p>L'efficienza di un canale ALOHA è molto bassa.<br/>
Possiamo assumere che le stazioni genereranno nuovi frame, e ritrasmetteranno quelli persi,
in accordo con la distribuzione di Poisson.</p>

<p>Sotto questa ipotesi, la capacità di trasporto massima per un canale ALOHA è <code>1/2e</code> (circa il 18%).</p>

<h3>ALOHA slotted</h3>

<p>Si tratta del sistema ALOHA in cui il tempo è suddiviso in intervalli discreti (<strong>slot</strong>).</p>

<p>Ogni trasmissione può quindi iniziare solo in corrispondenza di uno slot, eliminando
la possibilità delle collisioni parziali.</p>

<p><img src="04_aloha_slotted.gif" alt="Periodo vulnerabile in ALOHA slotted" /></p>

<h4>Efficienza di ALOHA slotted</h4>

<p>Il periodo di vulnerabilità dei frame viene dimezzato, raddoppiando la probabilità di trasmissione con successo: <code>1/e</code> (circa il 37%).</p>

<p>La migliore situazione ottenibile con slotted ALOHA prevede 37% trasmissioni senza errori,
37% intervalli vuoti e 26% collisioni.</p>

<h3>CSMA</h3>

<p>Per ottenere un utilizzo del canale maggiore di <code>1/e</code> (slotted ALOHA) si usano <strong>protocolli
con rilevamento della portante</strong>, in cui le stazioni ascoltano il canale e regolano
il loro comportamento di conseguenza.</p>

<p>I seguenti protocolli sono del tipo <strong>CSMA</strong> (<em>Carrier Sense Multiple Access</em>).</p>

<h4>CSMA 1-persistente</h4>

<p>Una stazione che intende trasmettere, prima di tutto ascolta il canale. Se il canale è
occupato (ovvero se rileva la portante), attende fino a quando non si libera.<br/>
Quando si accorge che il canale è libero trasmette un frame. In caso di collisione,
attende un periodo casuale e riprova.</p>

<p>Il protocollo si chiama <em>1-persistente</em> perché quando il canale è libero la
stazione trasmette con probabilità <code>1</code>.</p>

<p>Le collisioni possono comunque avvenire, per due motivi:</p>

<ul>
<li>quando il canale è libero, più di una stazione tenta la trasmissione</li>
<li>per via di ritardi di propagazione del segnale, quando una stazione sta
trasmettendo, per un'altra stazione il canale potrebbe risultare ancora libero</li>
</ul>


<h4>CSMA non persistente</h4>

<p>La stazione non controlla continuamente la disponibilità del canale, ma attende
per un intervallo casuale prima di ricontrollare il canale. Questo permette di
utilizzare meglio il canale, ma aumenta i ritardi.</p>

<h4>CSMA p-persistente</h4>

<p>Si applica ai canali divisi in intervalli temporali.</p>

<p>La stazione che intende trasmettere, non appena il canale è libero, trasmette
con probabilità <code>p</code>, e attende (come se ci fosse stata una collisione) con probabilità
<code>1 - p</code>.</p>

<p>Per <code>p</code> piccolo, i ritardi aumentano ulteriormente, ma si riducono sensibilmente
le collisioni, quindi l'efficienza è molto elevata.</p>

<h4>CSMA/CD (Collision Detection)</h4>

<p>Come il normale CSMA, ma ogni stazione può interrompere la propria trasmissione
immediatamente in caso di collisione, liberando subito il canale.<br/>
Questo è il protocollo che il sottostrato MAC utilizza nelle LAN Ethernet.</p>

<p>Il rilevamento della collisione è un processo <strong>analogico</strong>. Una collisione tra
due segnali a 0V non verrà mai rilevata, pertanto si usano speciali codifiche.</p>

<p>Una trasmissione CSMA/CD è intrinsecamente <em>half-duplex</em>, in quanto ogni stazione
mentre trasmette è in ascolto del canale per le collisioni.</p>

<p><img src="04_csma_cd.jpg" alt="Modello CSMA/CD" /></p>

<p>Il modello di CSMA/CD è composto da periodi di contesa alternati a periodi di
trasmissione, con periodi inattivi quando nessuna stazione deve trasmettere.</p>

<h5>Intervallo di di contesa</h5>

<p>Chiamiamo <strong>&tau;</strong> il tempo di propagazione lungo l'intero cavo. Una stazione
può essere certa di avere il controllo del canale solo se non rileva alcuna collisione
per un tempo pari a <strong>2&tau;</strong>.<br/>
Dopo aver acquisito il canale, la stazione può trasmettere alla velocità
che desidera (senza dover attendere altri intevalli <strong>2&tau;</strong>).</p>

<p>Nel caso peggiore viene trasmesso un frame, ma poco prima di &tau; la stazione
all'altra estremità (che vede il canale ancora libero) inizia a trasmettere.<br/>
La seconda stazione rileva subito la collisione e interrompe la trasmissione.
La prima stazione rileverà la collisione solo dopo un tempo pari a <strong>2&tau;</strong>.</p>

<p>L'intervallo di contesa viene rappresentato come un sistema slotted ALOHA con
intervalli lunghi <strong>2&tau;</strong>.</p>

<h3>Protocolli senza collisioni</h3>

<p>Quando il cavo è lungo e i frame sono corti, CSMA/CD è molto inefficiente. Esistono
protocolli che evitano del tutto le collisioni.</p>

<h4>Protocollo a mappa di bit</h4>

<p>Ogni periodo di contesa è composto esattamente da N intervalli (quante sono le stazioni).</p>

<p>Durante l'intervallo <code>k</code>, solo la stazione <code>k</code> può trasmettere un bit <code>1</code> per
indicare l'intenzione di trasmettere.</p>

<p>Al termine del periodo di contesa, ogni stazione vedrà la <strong>mappa di bit</strong>, che
conterrà un <code>1</code> per ogni stazione che vuole trasmettere.<br/>
Dopodiché le stazioni semplicemente trasmetteranno in ordine numerico.</p>

<p>Indicando con <code>d</code> la lunghezza di un frame dati, e con <code>N</code> la lunghezza della
bitmap (quindi i bit contenuti), l'efficienza di questo protocollo è uguale
a <code>d / (d + N)</code>.<br/>
Se il carico è elevato, cioè se tutte le stazioni trasmettono, il periodo di contesa
N è distribuito uniformemente tra le stazioni, quindi l'efficienza aumenta a <code>d / (d + 1)</code>.</p>

<p>La mappa di bit non si adatta alle reti composte da migliaia di stazioni:
il periodo di contesa sarebbe troppo lungo e l'efficienza bassa in condizioni di
poco carico.</p>

<h4>Conteggio binario</h4>

<p>Questo protocollo è più adatto a gestire reti composte da molte stazioni.</p>

<p>Si assegna ad ogni stazione un indirizzo binario della stessa lunghezza.<br/>
Prima della trasmissione, ogni stazione trasmette contemporaneamente il proprio
indirizzo, partendo dal bit più significativo.</p>

<p>La stazione rinuncia a trasmettere se una posizione in cui il proprio indirizzo
è <code>0</code> è stata sovrascritta da un <code>1</code>, ovvero se esiste una stazione con indirizzo
più alto che vuole trasmettere.</p>

<p>Questo metodo privilegia alcune stazioni a discapito di altre. Ciò può essere un
vantaggio o uno svantaggio a seconda dei casi.<br/>
Per aumentare il livello di equità si possono far ruotare gli indirizzi (ad una
stazione che ha trasmesso di recente verrà assegnato un indirizzo basso).</p>

<p>Con questo metodo l'efficienza del canale è pari a <code>d / (d + log2(N))</code>, ma se
il formato del frame viene scelto in modo che l'indirizzo del mittente sia
anche il primo campo del frame, si elimina anche questo overhead e l'efficienza
raggiunge il 100%.</p>

<h3>Protocolli a turno (token)</h3>

<p>Nei protocolli a turno una stazione alla volta ha il diritto di trasmettere.</p>

<h4>Token ring</h4>

<p>Noto anche come standard <strong>IEEE 802.5</strong>.</p>

<p>Il <strong>Token ring</strong> prevede che tutti i nodi siano collegati secondo
una struttura ad anello fisico e che, in ogni momento, solo uno di questi
(quello che possiede il <strong>token</strong>) possa trasmettere.</p>

<p>La stazione attiva invia i dati alla stazione vicina che, se non è il destinatario,
li invia a sua volta alla prossima stazione e così via.<br/>
Quando il frame viene ricevuto, il destinatario imposta un bit nel frame così che,
quando ritorna al mittente, esso saprà che il frame è stato ricevuto.</p>

<p>Quando la stazione che è in possesso del token ha terminato la trasmissione
dei dati passa il token a quella vicina. Quest'ultima se deve trasmettere
dati inizia la comunicazione, altrimenti cede immediatamente il token senza
impegnare il canale.</p>

<p>Ogni calcolatore, ogni volta che riceve il token, può trasmettere al massimo
un solo frame, quindi deve consegnare il token al terminale vicino.</p>

<p>Ogni terminale prima o poi riceverà il token ed avrà quindi la possibilità di trasmettere.<br/>
I dispositivi di rete garantiscono la presenza di un solo token sull'anello e provvedono
a rigenerarne uno qualora questo venga perso a causa di guasti nella rete o al
calcolatore che l'ha preso in consegna.<br/>
Si tratta dunque di una modalità di accesso multiplo di tipo TDMA scandita dal token.</p>

<h4>Token bus</h4>

<p>Noto anche come standard <strong>IEEE 802.4</strong>.</p>

<p>Il <strong>Token bus</strong> è una naturale evoluzione del Token Ring.</p>

<p>La struttura è ad anello <em>logico</em> (può avere qualsiasi topologia fisica).
Ogni nodo deve conoscere l'indirizzo di quello successivo in modo da formare
una mappa interna della rete per instradare correttamente i pacchetti da inviare.</p>

<p>Il vantaggio del token bus rispetto al più semplice token ring è che esso
rappresenta una valida alternativa quando non c'è possibilità di stendere
fisicamente una rete ad anello.<br/>
Il bus è infatti una rete comoda che può essere inserita facilmente in qualsiasi tipo di edificio.</p>

<h2>Ethernet</h2>

<p>Ethernet è anche noto come lo standard <strong>IEEE 802.3</strong>.</p>

<p>Generalmente si utilizzano quattro tipi di cavi:</p>

<table>
<thead>
<tr>
<th style="text-align:left;"> Nome </th>
<th style="text-align:left;"> Cavo </th>
<th style="text-align:left;"> Lunghezza max. segmento </th>
<th style="text-align:left;"> Nodi / segmento </th>
<th style="text-align:left;"> Connessione </th>
<th> Note </th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;"> <strong>10Base5</strong> </td>
<td style="text-align:left;"> Coassiale spesso (<em>thick Ethernet</em>) </td>
<td style="text-align:left;"> 500 m </td>
<td style="text-align:left;"> 100 </td>
<td style="text-align:left;"> Spine a vampiro su cavo condiviso </td>
<td> Obsoleto </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>10Base2</strong> </td>
<td style="text-align:left;"> Coassiale sottile (<em>thin Ethernet</em>) </td>
<td style="text-align:left;"> 185 m </td>
<td style="text-align:left;"> 30 </td>
<td style="text-align:left;"> Connettori BNC (giunzioni a T) su cavo condiviso </td>
<td> Non occore un hub </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>10Base-T</strong> </td>
<td style="text-align:left;"> Doppino intrecciato (UTP) </td>
<td style="text-align:left;"> 100 m </td>
<td style="text-align:left;"> 1024 </td>
<td style="text-align:left;"> Tramite hub (cavi dedicati) </td>
<td> Il più economico e usato </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>10Base-F</strong> </td>
<td style="text-align:left;"> Fibra ottica </td>
<td style="text-align:left;"> 2000 m </td>
<td style="text-align:left;"> 1024 </td>
<td style="text-align:left;"> Tramite hub (cavi dedicati) </td>
<td> Il migliore tra edifici </td>
</tr>
</tbody>
</table>


<p>Il prefisso <em>10Base</em> indica che la trasmissione avviene in banda base a 10 Mbps.</p>

<h4>Ripetitori</h4>

<p>Per creare reti più lunghe, si può fare uso di <strong>ripetitori</strong>: dispositivi dello
strato fisico che amplificano e ritrasmettono in entrambe le direzioni.<br/>
Un sistema può contenere un qualsiasi numero di ripetitori, a condizione che
ogni coppia di stazioni disti al massimo 2.5 km e attraversi al massimo 4 ripetitori</p>

<p>Dal punto di vista software, il ripetitore è trasparente, l'unica differenza riguarda
il ritardo introdotto.</p>

<h3>Backoff esponenziale binario</h3>

<p>Ethernet e i suoi successori utilizzano, in caso di collisioni, il <strong>backoff
esponenziale binario</strong>: dopo <code>i</code> collisioni consecutive, si attende un numero
random di intervalli di 512 bit, tra 0 e 2<sup>i</sup> - 1.</p>

<p>Es: dopo 3 collisioni si attende tra 0 e 7 intervalli da 512 bit (51,2 ms in Ethernet).</p>

<p>Dopo 10 collisioni consecutive l'algoritmo rinuncia e manda un errore al livello superiore.</p>

<h3>Codifica Manchester</h3>

<p>Trasmettendo 0V per <code>0</code> e 5V per <code>1</code> si crea ambiguità: il ricevente non può
distinguere tra linea libera e una lunga sequenza di <code>0</code>. Inoltre velocità
di clock diverse possono fare interpretare erroneamente la lunghezza di sequenze
di <code>1</code> o <code>0</code>. La soluzione è la <strong>codifica Manchester</strong>.</p>

<p>Ogni bit è trasmesso con due impulsi: una transizione alto-basso vale <code>1</code> e una
basso-alto vale <code>0</code>. In questo modo si elimina ogni ambiguità, e c'è sempre un
modo per sincronizzarsi con il clock del trasmittente.<br/>
Lo svantaggio è che richiede il doppio della banda, dovendo trasmettere il doppio
degli impulsi.</p>

<p>Una variante (non usata in Ethernet ma ad esempio in 802.5 token ring) è la
<strong>codifica Manchester differenziale</strong>: ad ogni bit <code>1</code> si inverte la transizione
(da alto-basso a basso-alto o viceversa).</p>

<p><img src="04_manchester.jpg" alt="Codifica Manchester" /></p>

<h3>Formato dei frame Ethernet</h3>

<table>
<thead>
<tr>
<th style="text-align:center;"> 7         </th>
<th> 1   </th>
<th> 6                      </th>
<th> 6                 </th>
<th> 2              </th>
<th> 46-1500  </th>
<th> 4        </th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:center;"> Preambolo </td>
<td> SoF </td>
<td> Indirizzo destinazione </td>
<td> Indirizzo origine </td>
<td> Lunghezza/Tipo </td>
<td> Dati/Pad </td>
<td> Checksum </td>
</tr>
</tbody>
</table>


<p>Il preambolo consiste nella sequenza 1010101 (che genera un'onda quadra permettendo la sincronizzazione
dei clock), seguita dal bit <em>Start of Frame</em>. Tecnicamente il frame Ethernet comincia dopo il bit SoF.</p>

<p>Se il campo <em>Lunghezza</em> vale più di 1500 (la lunghezza massima del frame) è intepretato come <em>Tipo</em>
(pacchetti di controllo, oppure indica il protocollo dello strato Network che dovrà prendersi carico del frame).</p>

<h4>Indirizzi speciali</h4>

<p>Il bit più significativo (47) dell'indirizzo di destinazione è <code>0</code> per gli indirizzi ordinari
o <code>1</code> per gli indirizzi <em>multicast</em>. L'indirizzo speciale formato da tutti <code>1</code> è l'indirizzo
<em>broadcast</em>.</p>

<p>Il secondo bit significativo (46) di entrambi gli indirizzi distingue tra <strong>indirizzi globali</strong>
(assegnati da IEEE e univoci in tutto il mondo) e <strong>indirizzi locali</strong> (assegnati dall'amministratore
di rete e univoci all'interno della LAN)</p>

<h4>Lunghezza del frame</h4>

<p>I dati possono essere al massimo <strong>1500 byte</strong>. Il frame ha anche una lunghezza minima: <strong>64 byte</strong>, preambolo escluso.<br/>
Se i dati sono meno di 46 byte, il campo dati viene riempito artificialmente per raggiungere la lunghezza minima.</p>

<p>La causa è il metodo <strong>CSMA/CD</strong>, usato da Ethernet: bisogna impedire che una stazione completi
l'invio di un frame senza che almeno un bit abbia raggiunto l'altra estremità del cavo.<br/>
Infatti all'altra estremità, in caso di collisione, l'altra stazione genererà un
<strong>burst di rumore</strong> da 48 bit per avvertire le altre stazioni della collisione.<br/>
Questo burst deve raggiungere la trasmittente prima che completi l'invio del frame,
che dovrà annullare l'invio e ritentare dopo un periodo casuale.</p>

<p>Considerando il caso peggiore (2500 metri con quattro ripetitori), il viaggio
andata e ritorno di un segnale impiega 50 ms.<br/>
A 10 Mbps, ogni bit impiega 100 ns, quindi sono necessari 500 bit per rispettare
tutte le condizioni. Questo valore è stato poi arrotondato a 512 bit (64 byte).</p>

<p>Al crescere della velocità della rete, la lunghezza minima del frame deve aumentare o,
proporzionalmente, deve diminuire la lunghezza massima del cavo.</p>

<h3>Fast Ethernet</h3>

<p>Anche nota come standard <strong>IEEE 802.3u</strong>, estende (mantenendo la compatibilità) lo
standard Ethernet.</p>

<p>Sono ammessi soltanto cavi UTP o fibre ottiche.</p>

<table>
<thead>
<tr>
<th style="text-align:left;"> Nome </th>
<th style="text-align:left;"> Cavo </th>
<th style="text-align:left;"> Lunghezza max. segmento </th>
<th style="text-align:left;"> Codifica </th>
<th style="text-align:left;"> Comunicazione </th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;"> <strong>100Base-T4</strong> </td>
<td style="text-align:left;"> UTP cat. 3 (4 cavi) </td>
<td style="text-align:left;"> 100 m </td>
<td style="text-align:left;"> 8B/6T </td>
<td style="text-align:left;"> Half duplex </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>100Base-TX</strong> </td>
<td style="text-align:left;"> UTP cat. 5 </td>
<td style="text-align:left;"> 100 m </td>
<td style="text-align:left;"> 4B/5B </td>
<td style="text-align:left;"> Full duplex </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>100Base-FX</strong> </td>
<td style="text-align:left;"> Fibra ottica </td>
<td style="text-align:left;"> 2000 m </td>
<td style="text-align:left;"> </td>
<td style="text-align:left;"> Full duplex </td>
</tr>
</tbody>
</table>


<p>Gli switch supportano il collegamento di cavi Ethernet e Fast Ethernet contemporaneamente:
in schede a velocità diverse (10 e 100 Mbps) o nella stessa scheda.<br/>
Infatti, lo standard Fast Ethernet permette di negoziare la velocità e la modalità
(half/full duplex) prima della comunicazione.</p>

<h4>100Base-T4: UTP cat. 3 con 8B/6T e MLT-3</h4>

<p>Il doppino di categoria 3 non ha la capacità di trasportare segnali di 200 Megabaud
(ricordiamo che con la codifica Manchester ci sono due simboli per bit), quindi per i
cavi di tipo <em>100Base-T4</em> sono necessari quattro doppini.</p>

<p>Il segnale viaggia a 25 MHz su ogni cavo, con <strong>tre livelli</strong> di tensione (<strong>MLT-3</strong>).<br/>
Un doppino è dedicato alla trasmissione, uno alla ricezione, e gli altri due sono direzionabili.</p>

<p>Con tre cavi, trasmettendo segnali ternari, si trasmette un simbolo in un alfabeto di 27, ovvero 4 bit
con un po' di ridondanza. A 25 MHz si raggiungono i 100 Mbps, più un canale a 33 Mbps in ricezione.</p>

<p>Questo schema è chiamato <strong>8B/6T</strong> (8 bit codificati in 6 trit).
Non è molto elegante ma funziona con i cavi esistenti.</p>

<h4>100Base-TX: UTP cat. 5 con 4B/5B</h4>

<p>I cavi cat. 5 possono gestire velocità di clock di 125 MHz, quindi la gestione è più semplice.<br/>
È possibile la comunicazione full duplex a 100 Mbps.</p>

<p>Si utilizza una codifica chiamata <strong>4B/5B</strong> (4 bit codificati con 5 bit): delle 32 combinazioni
possibili con 5 bit, 16 (4 bit) sono dedicate ai dati, con particolare attenzione a mantenere
alto il numero delle transizioni. Le altre combinazioni sono caratteri di controllo (es. limiti del frame).</p>

<h4>100Base-FX: fibra ottica</h4>

<p>Si utilizza una coppia di cavi in fibra multimodale per la comunicazione full duplex.</p>

<h3>Gigabit Ethernet</h3>

<p>Anche nota come standard <strong>IEEE 802.3z</strong>, estende retrocompatibilmente gli standard Fast Ethernet ed Ethernet.</p>

<p>Sono ammessi cavi UTP, STP (doppini schermati) o fibre ottiche.</p>

<table>
<thead>
<tr>
<th style="text-align:left;"> Nome </th>
<th style="text-align:left;"> Cavo </th>
<th style="text-align:left;"> Lunghezza max. segmento </th>
<th style="text-align:left;"> Codifica </th>
<th style="text-align:left;"> Note </th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;"> <strong>1000Base-SX</strong> </td>
<td style="text-align:left;"> Fibra ottica multimodale (50 o 62,5 &micro;m) </td>
<td style="text-align:left;"> 550 m </td>
<td style="text-align:left;"> 8B/10B </td>
<td></td>
</tr>
<tr>
<td style="text-align:left;"> <strong>1000Base-SL</strong> </td>
<td style="text-align:left;"> Fibra ottica monomodale (10 &micro;m) o multimodale (50 o 62,5 &micro;m) </td>
<td style="text-align:left;"> 5000 m </td>
<td style="text-align:left;"> 8B/10B </td>
<td></td>
</tr>
<tr>
<td style="text-align:left;"> <strong>1000Base-CX</strong> </td>
<td style="text-align:left;"> STP (2 cavi) </td>
<td style="text-align:left;"> 25 m </td>
<td style="text-align:left;"> </td>
<td style="text-align:left;"> Poco usata </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>1000Base-T</strong> </td>
<td style="text-align:left;"> UTP cat. 5 (4 cavi) </td>
<td style="text-align:left;"> 100 m </td>
<td style="text-align:left;"> 5 livelli di tensione </td>
<td style="text-align:left;"> Economica, basata su cavi già installati negli uffici </td>
</tr>
</tbody>
</table>


<p>Tutte le configurazioni Gigabit Ethernet sono punto-punto, abbandonando il sistema
multidrop che ora viene chiamato <strong>Ethernet classico</strong>.</p>

<p>Come per Fast Ethernet, gli switch possono gestire più velocità, ed è possibile
l'autoconfigurazione del collegamento.</p>

<h4>Modalità di comunicazione</h4>

<p>Le comunicazioni sono <strong>full-duplex</strong> quando le stazioni sono collegate tramite
switch con un buffer per ogni connettore.<br/>
Non essendoci nessuna collisione, non si usa <em>CSMA/CD</em>, e la lunghezza massima
del cavo è data solo dalla forza del segnale.</p>

<p>Le comunicazioni sono invece <strong>half-duplex</strong> quando più computer sono collegati tramite hub (che
è un semplice collegamento elettrico), in quanto è usato <em>CSMA/CD</em>.<br/>
Questa modalità è usata raramente, e solo per interoperabilità con Ethernet e Fast Ethernet.</p>

<p>Poiché il frame minimo (64 byte) può essere trasmesso 100 volte più velocemente,
la distanza massima risulta 100 volte più corta (25 metri), inaccettabile.</p>

<p>Lo standard IEEE 802.3z ha introdotto una dimensione minima di 512 byte, con i quali
la lunghezza massima diventa 200 metri.<br/>
Questa dimensione è ottenibile con i frame standard mediante due tecniche:</p>

<ul>
<li><strong>carrier extension</strong>: dei dati vengono aggiunti ai frame più corti, e rimossi
a destinazione in modo trasparente al software. Naturalmente usare 512 byte per
trasmetterne 46 (il carico utile di un frame da 64 byte) comporta un'efficienza del 9%</li>
<li><strong>frame bursting</strong>: una singola trasmissione può concatenare più frame.
Anche in questo caso vengono aggiunti dati se il totale non supera i 512 byte</li>
</ul>


<h4>Controllo di flusso</h4>

<p>La velocità di Gigabit Ethernet è talmente elevata che il canale si può affollare
anche con un minimo ritardo nella risposta, oppure se si collega a reti Ethernet più lente.</p>

<p>La logica conseguenza è che Gigabit Ethernet supporta il <strong>controllo di flusso</strong>:</p>

<ol>
<li>una stazione invia all'altra uno speciale pacchetto con tipo <code>0x8808</code> (<em>controllo</em>)</li>
<li>i primi due byte del campo dati indicano il comando (in questo caso <code>PAUSE</code>)</li>
<li>i byte successivi del campo dati indicano eventuali parametri (in questo caso la durata della pausa, in unità di tempo di frame, che in Gigabit Ethernet è 512 ns).</li>
</ol>


<h4>1000Base-SX, 1000Base-LX: fibre ottiche</h4>

<p>I LED non riescono ad operare ad una frequenza dell'ordine dei nanosecondi, quindi
per trasmettere a 1 Gbps sono necessari i laser.</p>

<p>La codifica Manchester richiederebbe trasmissioni a 2 Gigabaud.
Si utilizza perciò una codifica chiamata <strong>8B/10B</strong> (8 bit codificati con 10 bit).</p>

<p>Poiché ci sono 1024 codeword possibili per ogni byte, i codeword sono selezionati
per avere un numero sufficiente di transizioni:</p>

<ul>
<li>nessun codeword può avere più di quattro bit identici consecutivi</li>
<li>nessun codeword può avere più di sei <code>0</code> o <code>1</code></li>
</ul>


<p>Molti byte possono avere diversi codeword. La scelta è fatta in modo da bilanciare
il numero di <code>0</code> e <code>1</code> nella linea per minimizzare la componente DC, che verrebbe
filtrata dai trasformatori.<br/>
Per l'esattezza, in 20 bit (due byte) la differenza tra bit <code>1</code> e bit <code>0</code> deve essere
al massimo di 2.</p>

<h4>1000Base-T: UTP cat. 5 con PAM 5x5</h4>

<p>Sui cavi in rame è impossibile mantenere temporizzazioni di 1 ns. Si utilizza una
codifica basata su <strong>5 livelli</strong> di tensione (<strong>PAM 5x5</strong>), uno dei quali è utilizzato
per informazioni di controllo.</p>

<p>Si utilizzano quattro cavi UTP cat. 5 a 125 MHz (senza codifica 4B/5B). Attraverso
ognuno di essi passano simboli a 5 livelli, di cui 4 per i dati, che riescono a
codificare 2 bit per simbolo.<br/>
Nei quattro i cavi passano quindi 8 bit per ogni ciclo, raggiungendo 1 Gbps.</p>

<p>Viene utilizzato un metodo <strong>FEC</strong> (<em>Forward Error Correction</em>) per ottenere un
guadagno di 6 dB (in termini di SNR, dove nel rumore sono inclusi gli errori sui bit)</p>

<h3>LLC (Logical Link Control)</h3>

<p>Noto anche come lo standard IEEE 802.2, è protocollo Data Link che opera sopra
tutti gli standard 802 (come Ethernet), e ha le seguenti funzioni:</p>

<ul>
<li>nascodere le differenze tra i vari tipi di reti 802 fornendo un'unica interfaccia allo strato Network</li>
<li>fornire servizi datagram con acknowledge oppure orientati alla connessione</li>
</ul>


<p>Si può affermare che lo strato Data Link è composto da LLC (metà superiore) e MAC (metà inferiore).</p>

<p>I campi di LLC sono: access point sorgente, access point destinatario e un campo di controllo, con
numero di sequenza e di acknowledge.<br/>
Per Internet sono sufficienti i tentativi di trasmissione best-effort dei pacchetti IP
(il controllo di errore è compito degli strati superiori) quindi i campi di LLC non vengono usati.</p>

<h2>Reti wireless LAN</h2>

<p>Le reti <strong>WLAN</strong> sono definite dalla famiglia di standard IEEE 802.11 (a, b, g, n, &hellip;).<br/>
Sono diverse da Ethernet per via della complessità intrinseca dell'ambiente wireless.</p>

<p>Si tratta di protocolli <strong>CSMA/CA</strong> (<em>Collision Avoidance</em>).</p>

<h3>MACA (Multiple Access with Collision Avoidance)</h3>

<p>Il CSMA/CD standard non è applicabile per almeno due motivi:</p>

<ul>
<li><strong>Problema del terminale nascosto</strong>: un host non vede che un altro host sta già
trasmettendo, e prova a trasmettere, generando una collisione</li>
<li><strong>Problema del terminale esposto</strong>: un host trasmette ad un altro, e involontariamente
non permette ad un terzo host nel suo raggio d'azione di trasmettere.</li>
</ul>


<p>Per risolvere questi due problemi si utilizza <strong>MACA</strong> (<em>Multiple Access with Collision Avoidance</em>).</p>

<p>Un host, prima di trasmettere, invia a tutti i vicini un frame <strong>RTS</strong>
(<em>Request To Send</em>), indicando che ha intenzione di trasmettere un frame di
una determinata dimensione.</p>

<p>Tutti i vicini allora inviano ai loro vicini un frame <strong>CTS</strong> (<em>Clear To Send</em>),
chiedendo di non trasmettere nulla perchè attendono un frame. Così anche chi non
può sentire direttamente il primo host evita di trasmettere, e permette una
comunicazione senza collisioni.</p>

<p>In caso di collisioni, comunque, si usa il backoff binario esponenziale.</p>

<h2>Switch (Ethernet commutata)</h2>

<p>Al crescere del numero di stazioni, la rete si satura, e diventa impossibile trasmettere.<br/>
La soluzione è usare dispositivi chiamati <strong>switch</strong>, che consiste in una scheda
backplane ad alta velocità su cui innestare 4-32 schede di linea, ognuna con 1-8 connettori.<br/>
Solitamente ogni connettore gestisce un collegamento 10Base-T verso una singola stazione.</p>

<p>Lo switch si aspetta al connettore un frame Ethernet standard, per cui è possibile collegare anche un hub.</p>

<p>Quando una stazione vuole trasmettere, invia un frame standard allo switch.<br/>
Se il frame è diretto ad una stazione nella stessa scheda, lo ricopia sul corrispondente connettore,
altrimenti lo trasmette alla scheda di destinazione tramite la scheda backplane.</p>

<h3>Gestione delle collisioni</h3>

<p>Le collisioni sono gestite in due modi, in base a come è costruito lo switch.<br/>
In entrambi i casi, lo switch crea <strong>domini di collisione indipendenti</strong>, che migliorano le prestazioni.</p>

<ul>
<li>ogni scheda è una LAN locale a parte, (dominio di collisione con le stazioni sulla stessa scheda)</li>
<li>ogni connettore ha un buffer che memorizza i frame (dominio di collisione con una sola stazione, nessuna collisione possibile)</li>
</ul>


<p>La seconda soluzione permette comunicazioni full duplex, visto che le stazioni non devono rimanere in ascolto del canale.</p>

<p>Per evitare di riempire il buffer con trasmissioni veloci, alcuni switch iniziano a inoltrare i frame
appena noto l'indirizzo di destinazione (<strong>commutazione diretta</strong> o <em>cut-through</em>).<br/>
La commutazione <strong>store-and-forward</strong>, invece, consiste nell'inoltrare il frame
solo dopo la completa ricezione.</p>

<h2>Bridge</h2>

<p>Un <strong>bridge</strong> implementa il livello fisico e quello Data Link. Permette di collegare
tra loro reti che implementano standard 802 differenti.</p>

<p>Lo strato LLC, per definizione, è lo stesso in tutte le reti, ma lo strato MAC
cambia. Il bridge ha bisogno di un sottostrato MAC per ognuno dei tipi di rete che
può gestire.</p>

<p><img src="04_bridge.jpg" alt="Attività svolte da un bridge LAN da 802.11 a 802.3" /></p>

<p>Il frame viene privato dell'intestazione MAC (es. Ethernet) lasciando solo quella LLC,
dopodiché viene generata un'intestazione MAC del tipo della rete di destinazione,
e il frame viene ritrasmesso a destinazione.</p>

<h3>Problematiche dei bridge</h3>

<p>I bridge, oltre ad effettuare la semplice conversione di formato MAC, devono
risolvere i seguenti problemi:</p>

<ul>
<li><strong>Formati di frame diversi</strong>: ogni trasmissione in una LAN diverse comporta uso
di processore, per la generazione delle intestazioni e il calcolo del nuovo checksum.</li>
<li><strong>Velocità diverse</strong>: il bridge deve avere un buffer e sperare che le trasmissioni
delle reti più veloci non lo riempiano</li>
<li><strong>Diverse lunghezze massime dei frame</strong>: questo è forse il problema principale.
Non è competenza di questo strato dividere il frame in due. Sostanzialmente non
c'è nessuna soluzione: per mantenere la trasparenza, i bridge scartano i frame
troppo lunghi per la destinazione</li>
<li><strong>Cifratura</strong>: trasmettendo da un canale con cifratura nello strato data link
(es. wireless 802.11) a uno senza cifratura (es. Ethernet 802.3) i dati rimarranno
cifrati perché il bridge non li decodifica (trasparenza) prima di mandarli a
destinazione. Se il frame fa il percorso contrario, sarà sempre trasmesso in chiaro.<br/>
Una soluzione sarebbe quella di implementare la cifratura in uno strato più alto
quando viene rilevato un bridge con reti senza cifratura, ma questo compromette
la trasparenza</li>
<li><strong>Qualità del servizio</strong>: il frame che entra in una rete Ethernet perderà qualsiasi
nozione di qualità del servizio che aveva in 802.11 o 802.15 (Bluetooth)</li>
</ul>


<h3>Tecniche di inoltro</h3>

<p>Esistono diverse tecniche di inoltro, utilizzate da tipi diversi di bridge:</p>

<ul>
<li><strong>Source routing</strong> (o <strong>end-to-end routing</strong>): il mittente scrive nel frame la lista dei nodi da attraversare.<br/>
Tale tecnica è utilizzata dai bridge Token Ring</li>
<li><strong>Routing by network address</strong>: l'indirizzo del destinatario è scritto nel frame.<br/>
Tale tecnica è utilizzata dai bridge trasparenti</li>
</ul>


<h3>Bridge trasparenti</h3>

<p>Collegando con un bridge due LAN dello stesso tipo, si raggiunge la completa
<strong>trasparenza</strong>: le due LAN non noteranno la presenza del bridge.</p>

<p>Nel caso di LAN diverse, la trasparenza è raggiunta in parte, ma rimane l'obiettivo
dei bridge trasparenti: la rete deve comportarsi come se tutte le stazioni fossero
collegate alla stessa LAN. Un bridge trasparente deve inoltrare tutti i pacchetti,
senza modificarne il contenuto.</p>

<p>Inizialmente il bridge non conosce la posizione delle stazioni (a quale LAN appartengono).<br/>
Il bridge è attivo in <strong>modalità promiscua</strong>: accetta e trasmette frame da ogni indirizzo.</p>

<p>La procedura di instradamento dipende dalla LAN di appartenenza di sorgente e destinazione:</p>

<ul>
<li>se le due stazioni appartengono alla stessa LAN, il frame viene scartato (è già gestito all'interno della LAN)</li>
<li>se le due stazioni appartengono a LAN diverse, il frame viene inoltrato</li>
<li>se la LAN di destinazione è sconosciuta, il frame è inoltrato a tutte le LAN</li>
</ul>


<h4>Apprendimento all'indietro</h4>

<p>Appena arriva un frame il bridge aggiorna la propria <strong>hash table</strong> con la LAN
di appartenenza del mittente, dopodiché se l'indirizzo è noto lo inoltra alla LAN corrispondente.<br/>
Se l'indirizzo del destinatario non è noto, il frame viene inoltrato a tutte le LAN
tranne quella di ingresso (<strong>flooding</strong>). Appena viene ricevuta una risposta, la hash table
viene aggiornata con la posizione del destinatario.<br/>
Questo metodo viene chiamato <strong>apprendimento all'indietro</strong>.</p>

<h4>Topologie dinamiche</h4>

<p>Per gestire topologie dinamiche (cambiare la posizione di una stazione), ogni entry
nella hash table ha anche il timestamp dell'ultimo frame ricevuto.
Entry piu vecchie di qualche minuto vengono scartate (e ricostruite via flooding).
Questo permette di scollegare e ricollegare altrove una stazione senza nessuna operazione sul bridge.</p>

<h3>Bridge spanning tree</h3>

<p>Per aumentare l'affidabilità, si possono installare due o più bridge in parallelo
tra coppie di LAN. Si viene però a creare un <strong>anello</strong>, che darebbe il via a un
ciclo infinito di invio di frame per il flooding iniziale.</p>

<p>La soluzione è l'algoritmo <strong>spanning tree</strong> (IEEE 802.1D), nel quale tutti i bridge della rete
comunicano tra loro per stabilire il percorso da far seguire ai frame.</p>

<p><img src="04_bridge_spanning_tree.jpg" alt="Algoritmo Spanning Tree" /></p>

<ol>
<li>Ogni bridge ha un numero di serie univoco, che viene comunicato agli altri bridge della rete.
Il bridge con il numero di serie più basso diventa il <strong>nodo principale</strong></li>
<li>Viene costruita una struttura ad albero con radice il nodo principale, che copra tutte le LAN,
eventualmente escludendo i bridge che generano anelli.</li>
<li>L'algoritmo tiene costantemente aggiornato l'albero, rilevando modifiche alla topologia.</li>
</ol>


<h2>Differenze tra i vari commutatori</h2>

<p>Di seguito una tabella di riepilogo:</p>

<table>
<thead>
<tr>
<th style="text-align:left;"> Strato </th>
<th style="text-align:left;"> Dispositivi </th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;"> Data Link </td>
<td style="text-align:left;"> Bridge, Switch </td>
</tr>
<tr>
<td style="text-align:left;"> Fisico </td>
<td style="text-align:left;"> Ripetitori, Hub </td>
</tr>
</tbody>
</table>


<p>I ripetitori amplificano e ritrasmettono in entrambe le direzioni. Hanno soltanto nozione dei volt.</p>

<p>Gli hub collegano elettricamente più linee, come se fossero una sola. Ne deriva che esse devono
lavorare alla stessa velocità e formano un unico dominio di collisione.</p>

<p>Gli switch collegano più stazioni/LAN dello stesso tipo.
Solitamente hanno un gran numero di porte, e ad ogni porta è collegata una singola stazione (computer).</p>

<p>I bridge collegano LAN, anche di tipo diverso e reagiscono a cambi di topologia. Hanno meno porte degli switch.</p>

<p><img src="04_hub_bridge_switch.jpg" alt="Differenze tra i vari commutatori" /></p>

<h2>VLAN (LAN virtuali)</h2>

<p>Le <strong>VLAN</strong> sono usate per separare la topologia logica da quella fisica. A volte ciò è necessario per vari motivi:</p>

<ul>
<li><strong>Sicurezza</strong>: una scheda di rete può sempre essere messa in <em>modalità promiscua</em> e catturare tutto il traffico di rete</li>
<li><strong>Carico</strong>: una parte dei computer satura la rete, impedendo agli altri di comunicare</li>
<li><strong>Trasmissioni broadcast</strong>: a volte una scheda di rete si rompe, generando un flusso continuo di trasmissioni broadcast che satura la rete e paralizza le stazioni, che devono elaborare tutti i frame (<strong>tempesta broadcast</strong>).<br/>
Un bridge o uno switch non è la soluzione, in quanto per essere trasparenti devono inoltrare anche questi pacchetti.</li>
</ul>


<p>Le VLAN permettono di ricablare un edificio interamente via software, con i seguenti vantaggi:</p>

<ul>
<li><strong>risparmio</strong>: riutilizzo delle linee e degli apparati preesistenti</li>
<li><strong>flessibilità</strong>: facile spostamento fisico degli utenti</li>
<li><strong>prestazioni</strong>: il traffico broadcast viene confinato, decongestionando la rete</li>
<li><strong>sicurezza</strong>: gli utenti di VLAN differenti non vedono i reciproci frame dati</li>
</ul>


<p>Le VLAN hanno bisogno di switch/bridge VLAN-compatibili, ma possono anche utilizzare hub nel perimetro esterno.<br/>
La figura seguente mostra le stesse quattro LAN organizzate in due VLAN (<em>white</em> e <em>grey</em>) con bridge o con switch:</p>

<p><img src="04_vlan.jpg" alt="VLAN" /></p>

<p>In maniera informale, alle diverse VLAN vengono dati dei nomi di colori, per poter rappresentare nello stesso diagramma la topologia fisica e quella logica.<br/>
Ogni porta è etichettata con uno o più colori, corrispondenti alle VLAN accessibili da quella porta.</p>

<h3>Tabelle di configurazione</h3>

<p>Per far funzionare correttamente le VLAN, nei bridge/switch devono essere impostate delle <strong>tabelle di configurazione</strong>,
che indicano quali VLAN sono accessibili attraverso le varie porte (linee).</p>

<p>Quando arriva un frame, questo deve essere inoltrato su tutte le porte contrassegnate con lo stesso colore della VLAN del mittente.<br/>
Questo vale per tutto il traffico (unicast, multicast, broadcast).</p>

<h3>VLAN untagged</h3>

<p>Per permettere ai bridge e agli switch di riconoscere le VLAN di destinazione, viene assegnato un colore VLAN:</p>

<ol>
<li>ad ogni porta (valido solo se a quella porta sono collegati solo computer della stessa VLAN)</li>
<li>ad ogni indirizzo MAC</li>
<li>ad ogni protocollo di livello 3 (es. indirizzo IP): utile nel caso di <em>docking stations</em> (indirizzi MAC diversi ma stesso IP), ma compromette la separazione tra gli strati</li>
</ol>


<h3>VLAN tagged (IEEE 802.1Q)</h3>

<p>Gli studi sulle VLAN hanno concluso che l'importante è la VLAN di appartenenza del messaggio, non del mittente.<br/>
La specifica <strong>802.1Q</strong> definisce un nuovo formato di frame Ethernet:</p>

<p><img src="04_vlan_802_1q.png" alt="VLAN" /></p>

<p>Prima del campo <em>lunghezza/tipo</em> si trovano due campi da due byte:</p>

<ul>
<li>Il campo <strong>Tag Protocol ID</strong>, che contiene sempre <code>0x8100</code> (essendo maggiore di 1500 è interpretato dalle schede non compatibili come un tipo)</li>
<li>Il campo <strong>Tag Control Information</strong>, un <em>bit field</em> di 2 byte:

<ul>
<li>i primi 3 bit sono il campo <strong>Priority</strong> (qualità del servizio: distingue il traffico in tempo reale da quello insensibile al tempo)</li>
<li>il seguente bit si chiama <strong>CFI</strong>, e distingue gli indirizzi MAC significativi da quelli meno significativi</li>
<li>gli ultimi 12 bit sono il <strong>VLAN ID</strong></li>
</ul>
</li>
</ul>


<p>I bridge/switch devono essere compatibili con 802.1Q (e normalmente lo sono).<br/>
Le tabelle di configurazione, per il noto requisito trasparenza dei commutatori, sono aggiornate automaticamente in base alle etichette dei frame passanti.</p>

<p>I frame vengono riconvertiti in 802.3 quando raggiungono stazioni non VLAN-compatibili.<br/>
Normalmente le schede di rete Gigabit Ethernet sono VLAN-compatibili, mentre le varianti più lente non lo sono.</p>

<h2>Riepilogo standard IEEE</h2>

<p>La seguente tabella riassume tutti gli standard IEEE presentati finora.</p>

<table>
<thead>
<tr>
<th style="text-align:left;"> Nome </th>
<th style="text-align:left;"> Scopo </th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.1D</strong> </td>
<td style="text-align:left;"> Algoritmo <em>spanning tree</em> per bridge </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.1Q</strong> </td>
<td style="text-align:left;"> VLAN tagged </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.2</strong> </td>
<td style="text-align:left;"> Logical Link Control </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.3</strong> </td>
<td style="text-align:left;"> Ethernet </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.3u</strong> </td>
<td style="text-align:left;"> Fast Ethernet </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.3z</strong> </td>
<td style="text-align:left;"> Gigabit Ethernet </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.4</strong> </td>
<td style="text-align:left;"> Token bus </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.5</strong> </td>
<td style="text-align:left;"> Token ring </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.11</strong> </td>
<td style="text-align:left;"> Wireless LAN </td>
</tr>
<tr>
<td style="text-align:left;"> <strong>IEEE 802.15</strong> </td>
<td style="text-align:left;"> Wireless PAN (es. Bluetooth) </td>
</tr>
</tbody>
</table>


<p>La famiglia di standard IEEE 802.1, nel suo insieme, raccoglie protocolli per LAN di livello più alto del semplice data link.</p>
</body>
</html>
